import AppHeader from "@/components/AppHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import ImageUser from "@/components/imageNew";
import ImageWithLabel from "@/components/imageWithLabel";
import InputSearch from "@/components/inputSearch";
import Text from "@/components/Text";
import { ConstEnv } from "@/constants/ConstEnv";
import Styles from "@/constants/Styles";
import { apiCreateCalendar, apiGetDivisionMember } from "@/lib/api";
import { setFormCreateCalendar } from "@/lib/calendarCreate";
import { setUpdateCalendar } from "@/lib/calendarUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { AntDesign } from "@expo/vector-icons";
import { router, Stack, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { Pressable, SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

type Props = {
   idUser: string,
   name: string,
   img: string
}

export default function CreateCalendarAddMember() {
   const { colors } = useTheme();
   const { token, decryptToken } = useAuthSession()
   const { id } = useLocalSearchParams<{ id: string }>()
   const [data, setData] = useState<Props[]>([])
   const [selectMember, setSelectMember] = useState<any[]>([])
   const [search, setSearch] = useState('')
   const update = useSelector((state: any) => state.calendarCreate)
   const dispatch = useDispatch()
   const updateRefresh = useSelector((state: any) => state.calendarUpdate)
   const [loading, setLoading] = useState(false)



   async function handleLoadMemberDivision() {
      const hasil = await decryptToken(String(token?.current))
      const responMemberDivision = await apiGetDivisionMember({ id: id, user: hasil, search: search })
      setData(responMemberDivision.data)
      if (update.member.length > 0) {
         setSelectMember(update.member)
      }
   }

   useEffect(() => {
      handleLoadMemberDivision()
   }, [search]);

   function onChoose(val: string, label: string, img?: string) {
      if (selectMember.some((i: any) => i.idUser == val)) {
         setSelectMember(selectMember.filter((i: any) => i.idUser != val))
      } else {
         setSelectMember([...selectMember, { idUser: val, name: label, img }])
      }
   }


   async function handleAddMember() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiCreateCalendar({ data: { ...update, user: hasil, idDivision: id, member: selectMember } })
         if (response.success) {
            Toast.show({ type: 'small', text1: 'Berhasil membuat acara', })
            dispatch(setFormCreateCalendar({
               title: "",
               desc: "",
               dateStart: "",
               timeStart: "",
               timeEnd: "",
               repeatEventType: "",
               repeatValue: 1,
               linkMeet: "",
               member: [],
            }))
            dispatch(setUpdateCalendar({ ...updateRefresh, data: !updateRefresh.data }));
            router.replace(`/division/${id}/calendar`)
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error: any) {
         console.error(error);
         const message = error?.response?.data?.message || "Gagal membuat acara"

         Toast.show({ type: 'small', text1: message })
      } finally {
         setLoading(false)
      }
   }

   return (
      <SafeAreaView style={{ flex: 1, backgroundColor: colors.background }}>
         <Stack.Screen
            options={{
               // headerLeft: () => <ButtonBackHeader onPress={() => { router.back() }} />,
               headerTitle: 'Pilih Anggota',
               headerTitleAlign: 'center',
               // headerRight: () => (
               //    <ButtonSaveHeader
               //       category="create"
               //       disable={selectMember.length == 0 || loading ? true : false}
               //       onPress={() => { handleAddMember() }}
               //    />
               // )
               header: () => (
                  <AppHeader
                     title="Pilih Anggota"
                     showBack={true}
                     onPressLeft={() => router.back()}
                     right={
                        <ButtonSaveHeader
                           category="create"
                           disable={selectMember.length == 0 || loading ? true : false}
                           onPress={() => { handleAddMember() }}
                        />
                     }
                  />
               )
            }}
         />
         <View style={[Styles.p15]}>
            <InputSearch onChange={(val) => setSearch(val)} value={search} />

            {
               selectMember.length > 0
                  ?
                  <View>
                     <ScrollView horizontal style={[Styles.mb10, Styles.pv10]} showsHorizontalScrollIndicator={false}>
                        {
                           selectMember.map((item: any, index: any) => (
                              <ImageWithLabel
                                 key={index}
                                 label={item.name}
                                 src={`${ConstEnv.url_storage}/files/${item.img}`}
                                 onClick={() => onChoose(item.idUser, item.name, item.img)}
                              />
                           ))
                        }
                     </ScrollView>
                  </View>

                  :
                  <Text style={[Styles.textDefault, Styles.pv05, { textAlign: 'center', color: colors.dimmed }]}>Tidak ada member yang dipilih</Text>
            }
            <ScrollView
               showsVerticalScrollIndicator={false}
               style={[Styles.h100]}
            >

               {
                  data.length > 0 ?
                     data.map((item: any, index: any) => {
                        return (
                           <Pressable
                              key={index}
                              style={[Styles.itemSelectModal, { borderColor: colors.icon + '20' }]}
                              onPress={() => { onChoose(item.idUser, item.name, item.img) }}
                           >
                              <View style={[Styles.rowItemsCenter, Styles.w70]}>
                                 <ImageUser src={`${ConstEnv.url_storage}/files/${item.img}`} border />
                                 <View style={[Styles.ml10]}>
                                    <Text style={[Styles.textDefault]} numberOfLines={1} ellipsizeMode="tail">{item.name}</Text>
                                 </View>
                              </View>
                              {
                                 selectMember.some((i: any) => i.idUser == item.idUser) && <AntDesign name="check" size={20} color={colors.text} />
                              }
                           </Pressable>
                        )
                     }
                     )
                     :
                     <Text style={[Styles.textDefault, { textAlign: 'center' }]}>Tidak ada data</Text>
               }
            </ScrollView>
         </View>
      </SafeAreaView>
   )
}